From 929d8f1ed0bcce78db795fe7cab9484c4e610a13 Mon Sep 17 00:00:00 2001
From: Sahil Harpal <santosh.2@iitj.ac.in>
Date: Wed, 16 Aug 2023 15:19:15 +0530
Subject: [PATCH 1/3] System stats changes except process and disk information

---
 web/pgadmin/dashboard/__init__.py             | 131 ++++++
 web/pgadmin/dashboard/static/js/Dashboard.jsx | 234 +++++++---
 .../dashboard/static/js/SystemStats/CPU.jsx   | 377 ++++++++++++++++
 .../static/js/SystemStats/Memory.jsx          | 372 +++++++++++++++
 .../static/js/SystemStats/Storage.jsx         | 329 ++++++++++++++
 .../static/js/SystemStats/Summary.jsx         | 422 ++++++++++++++++++
 .../sql/default/system_statistics.sql         | 100 +++++
 .../js/components/PgChart/DonutChart.jsx      |  70 +++
 .../js/components/PgChart/StreamingChart.jsx  | 146 ++++--
 9 files changed, 2090 insertions(+), 91 deletions(-)
 create mode 100644 web/pgadmin/dashboard/static/js/SystemStats/CPU.jsx
 create mode 100644 web/pgadmin/dashboard/static/js/SystemStats/Memory.jsx
 create mode 100644 web/pgadmin/dashboard/static/js/SystemStats/Storage.jsx
 create mode 100644 web/pgadmin/dashboard/static/js/SystemStats/Summary.jsx
 create mode 100644 web/pgadmin/dashboard/templates/dashboard/sql/default/system_statistics.sql
 create mode 100644 web/pgadmin/static/js/components/PgChart/DonutChart.jsx

diff --git a/web/pgadmin/dashboard/__init__.py b/web/pgadmin/dashboard/__init__.py
index 1dac54e74..c18f5d3de 100644
--- a/web/pgadmin/dashboard/__init__.py
+++ b/web/pgadmin/dashboard/__init__.py
@@ -112,6 +112,72 @@ class DashboardModule(PgAdminModule):
             help_str=help_string
         )
 
+        self.hpc_stats_refresh = self.dashboard_preference.register(
+            'dashboards', 'hpc_stats_refresh',
+            gettext("Handle & Process count statistics refresh rate"),
+            'integer', 5, min_val=1, max_val=999999,
+            category_label=PREF_LABEL_REFRESH_RATES,
+            help_str=help_string
+        )
+
+        self.cu_stats_refresh = self.dashboard_preference.register(
+            'dashboards', 'cu_stats_refresh',
+            gettext(
+                "Percentage of CPU time used by different process \
+                modes statistics refresh rate"
+            ), 'integer', 5, min_val=1, max_val=999999,
+            category_label=PREF_LABEL_REFRESH_RATES,
+            help_str=help_string
+        )
+
+        self.la_stats_refresh = self.dashboard_preference.register(
+            'dashboards', 'la_stats_refresh',
+            gettext("Average load statistics refresh rate"), 'integer',
+            5, min_val=1, max_val=999999,
+            category_label=PREF_LABEL_REFRESH_RATES,
+            help_str=help_string
+        )
+
+        self.pcu_stats_refresh = self.dashboard_preference.register(
+            'dashboards', 'pcu_stats_refresh',
+            gettext("CPU usage per process statistics refresh rate"),
+            'integer', 5, min_val=1, max_val=999999,
+            category_label=PREF_LABEL_REFRESH_RATES,
+            help_str=help_string
+        )
+
+        self.m_stats_refresh = self.dashboard_preference.register(
+            'dashboards', 'm_stats_refresh',
+            gettext("Memory usage statistics refresh rate"), 'integer',
+            5, min_val=1, max_val=999999,
+            category_label=PREF_LABEL_REFRESH_RATES,
+            help_str=help_string
+        )
+
+        self.sm_stats_refresh = self.dashboard_preference.register(
+            'dashboards', 'sm_stats_refresh',
+            gettext("Swap memory usage statistics refresh rate"), 'integer',
+            5, min_val=1, max_val=999999,
+            category_label=PREF_LABEL_REFRESH_RATES,
+            help_str=help_string
+        )
+
+        self.pmu_stats_refresh = self.dashboard_preference.register(
+            'dashboards', 'pmu_stats_refresh',
+            gettext("Memory usage per process statistics refresh rate"),
+            'integer', 5, min_val=1, max_val=999999,
+            category_label=PREF_LABEL_REFRESH_RATES,
+            help_str=help_string
+        )
+
+        self.io_stats_refresh = self.dashboard_preference.register(
+            'dashboards', 'io_stats_refresh',
+            gettext("I/O analysis statistics refresh rate"), 'integer',
+            5, min_val=1, max_val=999999,
+            category_label=PREF_LABEL_REFRESH_RATES,
+            help_str=help_string
+        )
+
         self.display_graphs = self.dashboard_preference.register(
             'display', 'show_graphs',
             gettext("Show graphs?"), 'boolean', True,
@@ -197,6 +263,12 @@ class DashboardModule(PgAdminModule):
             'dashboard.get_prepared_by_database_id',
             'dashboard.config',
             'dashboard.get_config_by_server_id',
+            'dashboard.check_system_statistics',
+            'dashboard.check_system_statistics_sid',
+            'dashboard.check_system_statistics_did',
+            'dashboard.system_statistics',
+            'dashboard.system_statistics_sid',
+            'dashboard.system_statistics_did',
         ]
 
 
@@ -536,3 +608,62 @@ def terminate_session(sid=None, did=None, pid=None):
         response=gettext("Success") if res else gettext("Failed"),
         status=200
     )
+
+
+# To check whether system stats extesion is present or not
+@blueprint.route('check_extension/system_statistics',
+                 endpoint='check_system_statistics', methods=['GET'])
+@blueprint.route('check_extension/system_statistics/<int:sid>',
+                 endpoint='check_system_statistics_sid', methods=['GET'])
+@blueprint.route('check_extension/system_statistics/<int:sid>/<int:did>',
+                 endpoint='check_system_statistics_did', methods=['GET'])
+@login_required
+@check_precondition
+def check_system_statistics(sid=None, did=None):
+    sql = "SELECT * FROM pg_extension WHERE extname = 'system_stats';"
+    status, res = g.conn.execute_scalar(sql)
+    if not status:
+        return internal_server_error(errormsg=res)
+    data = {}
+    if res is not None:
+        data['ss_present'] = True
+    else:
+        data['ss_present'] = False
+    return ajax_response(
+        response=data,
+        status=200
+    )
+
+
+# System Statistics Backend
+@blueprint.route('/system_statistics',
+                 endpoint='system_statistics', methods=['GET'])
+@blueprint.route('/system_statistics/<int:sid>',
+                 endpoint='system_statistics_sid', methods=['GET'])
+@blueprint.route('/system_statistics/<int:sid>/<int:did>',
+                 endpoint='system_statistics_did', methods=['GET'])
+@login_required
+@check_precondition
+def system_statistics(sid=None, did=None):
+    resp_data = {}
+
+    if request.args['chart_names'] != '':
+        chart_names = request.args['chart_names'].split(',')
+
+        if not sid:
+            return internal_server_error(errormsg='Server ID not specified.')
+
+        sql = render_template(
+            "/".join([g.template_path, 'system_statistics.sql']), did=did,
+            chart_names=chart_names,
+        )
+        status, res = g.conn.execute_dict(sql)
+
+        for chart_row in res['rows']:
+            resp_data[chart_row['chart_name']] = json.loads(
+                chart_row['chart_data'])
+
+    return ajax_response(
+        response=resp_data,
+        status=200
+    )
diff --git a/web/pgadmin/dashboard/static/js/Dashboard.jsx b/web/pgadmin/dashboard/static/js/Dashboard.jsx
index 7194fcc10..e6afeff07 100644
--- a/web/pgadmin/dashboard/static/js/Dashboard.jsx
+++ b/web/pgadmin/dashboard/static/js/Dashboard.jsx
@@ -29,6 +29,10 @@ import _ from 'lodash';
 import CachedOutlinedIcon from '@material-ui/icons/CachedOutlined';
 import EmptyPanelMessage from '../../../static/js/components/EmptyPanelMessage';
 import TabPanel from '../../../static/js/components/TabPanel';
+import Summary from 'SystemStats/Summary';
+import CPU from 'SystemStats/CPU';
+import Memory from 'SystemStats/Memory';
+import Storage from 'SystemStats/Storage';
 
 function parseData(data) {
   let res = [];
@@ -148,12 +152,21 @@ export default function Dashboard({
 }) {
   const classes = useStyles();
   let tabs = [gettext('Sessions'), gettext('Locks'), gettext('Prepared Transactions')];
+  let mainTabs = [gettext('General'), gettext('System Statistics')];
+  let systemStatsTabs = [gettext('Summary'), gettext('CPU'), gettext('Memory'), gettext('Storage')];
   const [dashData, setdashData] = useState([]);
   const [msg, setMsg] = useState('');
+  const [ssMsg, setSsMsg] = useState('');
   const [tabVal, setTabVal] = useState(0);
+  const [mainTabVal, setmainTabVal] = useState(0);
   const [refresh, setRefresh] = useState(false);
   const [activeOnly, setActiveOnly] = useState(false);
   const [schemaDict, setSchemaDict] = React.useState({});
+  const [systemStatsTabVal, setSystemStatsTabVal] = useState(0);
+
+  const systemStatsTabChanged = (e, tabVal) => {
+    setSystemStatsTabVal(tabVal);
+  };
 
   if (!did) {
     tabs.push(gettext('Configuration'));
@@ -163,6 +176,10 @@ export default function Dashboard({
     setTabVal(tabVal);
   };
 
+  const mainTabChanged = (e, tabVal) => {
+    setmainTabVal(tabVal);
+  };
+
   const serverConfigColumns = [
     {
       accessor: 'name',
@@ -745,6 +762,7 @@ export default function Dashboard({
 
   useEffect(() => {
     let url,
+      ss_extension_check_url = url_for('dashboard.check_system_statistics'),
       message = gettext(
         'Please connect to the selected server to view the dashboard.'
       );
@@ -770,6 +788,10 @@ export default function Dashboard({
       if (did) url += sid + '/' + did;
       else url += sid;
 
+      if (did && !props.dbConnected) return;
+      if (did) ss_extension_check_url += '/' + sid + '/' + did;
+      else ss_extension_check_url += '/' + sid;
+
       const api = getApiInstance();
       if (node) {
         api({
@@ -787,6 +809,20 @@ export default function Dashboard({
             // show failed message.
             setMsg(gettext('Failed to retrieve data from the server.'));
           });
+
+        api({
+          url: ss_extension_check_url,
+          type: 'GET',
+        })
+          .then((res) => {
+            const data = res.data;
+            if(data['ss_present'] == false){
+              setSsMsg(gettext('System stats extension is not installed. You can install the extension in a database using the "CREATE EXTENSION system_stats;" SQL command. Reload the pgAdmin once you installed.'));
+            }
+          })
+          .catch(() => {
+            setSsMsg(gettext('Failed to verify the presence of system stats extension.'));
+          });
       } else {
         setMsg(message);
       }
@@ -867,68 +903,148 @@ export default function Dashboard({
       {sid && props.serverConnected ? (
         <Box className={classes.dashboardPanel}>
           <Box className={classes.emptyPanel}>
-            {!_.isUndefined(preferences) && preferences.show_graphs && (
-              <Graphs
-                key={sid + did}
-                preferences={preferences}
-                sid={sid}
-                did={did}
-                pageVisible={props.panelVisible}
-              ></Graphs>
-            )}
-            {!_.isUndefined(preferences) && preferences.show_activity && (
-              <Box className={classes.panelContent}>
-                <Box
-                  className={classes.cardHeader}
-                  title={props.dbConnected ?  gettext('Database activity') : gettext('Server activity')}
-                >
-                  {props.dbConnected ?  gettext('Database activity') : gettext('Server activity')}{' '}
+            <Box className={classes.panelContent}>
+              <Box height="100%" display="flex" flexDirection="column">
+                <Box>
+                  <Tabs
+                    value={mainTabVal}
+                    onChange={mainTabChanged}
+                  >
+                    {mainTabs.map((tabValue) => {
+                      return <Tab key={tabValue} label={tabValue} />;
+                    })}
+                    <RefreshButton/>
+                  </Tabs>
                 </Box>
-                <Box height="100%" display="flex" flexDirection="column">
-                  <Box>
-                    <Tabs
-                      value={tabVal}
-                      onChange={tabChanged}
-                    >
-                      {tabs.map((tabValue) => {
-                        return <Tab key={tabValue} label={tabValue} />;
-                      })}
-                      <RefreshButton/>
-                    </Tabs>
+                {/* General Statistics */}
+                <TabPanel value={mainTabVal} index={0} classNameRoot={classes.tabPanel}>
+                  {!_.isUndefined(preferences) && preferences.show_graphs && (
+                    <Graphs
+                      key={sid + did}
+                      preferences={preferences}
+                      sid={sid}
+                      did={did}
+                      pageVisible={props.panelVisible}
+                    ></Graphs>
+                  )}
+                  {!_.isUndefined(preferences) && preferences.show_activity && (
+                    <Box className={classes.panelContent}>
+                      <Box
+                        className={classes.cardHeader}
+                        title={props.dbConnected ?  gettext('Database activity') : gettext('Server activity')}
+                      >
+                        {props.dbConnected ?  gettext('Database activity') : gettext('Server activity')}{' '}
+                      </Box>
+                      <Box height="100%" display="flex" flexDirection="column">
+                        <Box>
+                          <Tabs
+                            value={tabVal}
+                            onChange={tabChanged}
+                          >
+                            {tabs.map((tabValue) => {
+                              return <Tab key={tabValue} label={tabValue} />;
+                            })}
+                            <RefreshButton/>
+                          </Tabs>
+                        </Box>
+                        <TabPanel value={tabVal} index={0} classNameRoot={classes.tabPanel}>
+                          <PgTable
+                            caveTable={false}
+                            CustomHeader={CustomActiveOnlyHeader}
+                            columns={activityColumns}
+                            data={filteredDashData}
+                            schema={schemaDict}
+                          ></PgTable>
+                        </TabPanel>
+                        <TabPanel value={tabVal} index={1} classNameRoot={classes.tabPanel}>
+                          <PgTable
+                            caveTable={false}
+                            columns={databaseLocksColumns}
+                            data={dashData}
+                          ></PgTable>
+                        </TabPanel>
+                        <TabPanel value={tabVal} index={2} classNameRoot={classes.tabPanel}>
+                          <PgTable
+                            caveTable={false}
+                            columns={databasePreparedColumns}
+                            data={dashData}
+                          ></PgTable>
+                        </TabPanel>
+                        <TabPanel value={tabVal} index={3} classNameRoot={classes.tabPanel}>
+                          <PgTable
+                            caveTable={false}
+                            columns={serverConfigColumns}
+                            data={dashData}
+                          ></PgTable>
+                        </TabPanel>
+                      </Box>
+                    </Box>
+                  )}
+                </TabPanel>
+                {/* System Statistics */}
+                <TabPanel value={mainTabVal} index={1} classNameRoot={classes.tabPanel}>
+                  <Box height="100%" display="flex" flexDirection="column">
+                    {ssMsg === '' ?
+                      <>
+                        <Box>
+                          <Tabs
+                            value={systemStatsTabVal}
+                            onChange={systemStatsTabChanged}
+                          >
+                            {systemStatsTabs.map((tabValue) => {
+                              return <Tab key={tabValue} label={tabValue} />;
+                            })}
+                          </Tabs>
+                        </Box>
+                        <TabPanel value={systemStatsTabVal} index={0} classNameRoot={classes.tabPanel}>
+                          <Summary
+                            key={sid + did}
+                            preferences={preferences}
+                            sid={sid}
+                            did={did}
+                            pageVisible={props.panelVisible}
+                            serverConnected={props.serverConnected}
+                          />
+                        </TabPanel>
+                        <TabPanel value={systemStatsTabVal} index={1} classNameRoot={classes.tabPanel}>
+                          <CPU
+                            key={sid + did}
+                            preferences={preferences}
+                            sid={sid}
+                            did={did}
+                            pageVisible={props.panelVisible}
+                            serverConnected={props.serverConnected}
+                          />
+                        </TabPanel>
+                        <TabPanel value={systemStatsTabVal} index={2} classNameRoot={classes.tabPanel}>
+                          <Memory
+                            key={sid + did}
+                            preferences={preferences}
+                            sid={sid}
+                            did={did}
+                            pageVisible={props.panelVisible}
+                            serverConnected={props.serverConnected}
+                          />
+                        </TabPanel>
+                        <TabPanel value={systemStatsTabVal} index={3} classNameRoot={classes.tabPanel}>
+                          <Storage
+                            key={sid + did}
+                            preferences={preferences}
+                            sid={sid}
+                            did={did}
+                            pageVisible={props.panelVisible}
+                            serverConnected={props.serverConnected}
+                          />
+                        </TabPanel>
+                      </> :
+                      <div className={classes.emptyPanel}>
+                        <EmptyPanelMessage text={ssMsg}/>
+                      </div>
+                    }
                   </Box>
-                  <TabPanel value={tabVal} index={0} classNameRoot={classes.tabPanel}>
-                    <PgTable
-                      caveTable={false}
-                      CustomHeader={CustomActiveOnlyHeader}
-                      columns={activityColumns}
-                      data={filteredDashData}
-                      schema={schemaDict}
-                    ></PgTable>
-                  </TabPanel>
-                  <TabPanel value={tabVal} index={1} classNameRoot={classes.tabPanel}>
-                    <PgTable
-                      caveTable={false}
-                      columns={databaseLocksColumns}
-                      data={dashData}
-                    ></PgTable>
-                  </TabPanel>
-                  <TabPanel value={tabVal} index={2} classNameRoot={classes.tabPanel}>
-                    <PgTable
-                      caveTable={false}
-                      columns={databasePreparedColumns}
-                      data={dashData}
-                    ></PgTable>
-                  </TabPanel>
-                  <TabPanel value={tabVal} index={3} classNameRoot={classes.tabPanel}>
-                    <PgTable
-                      caveTable={false}
-                      columns={serverConfigColumns}
-                      data={dashData}
-                    ></PgTable>
-                  </TabPanel>
-                </Box>
+                </TabPanel>
               </Box>
-            )}
+            </Box>
           </Box>
         </Box>
       ) : showDefaultContents() }
